<?php
/*
 * Script:  iVDR
 * Comment: This script proxies VDR-Live for streaming with IOS device
 * Put on a local webserver and add page to homescreen for a nice launcher icon
 * Author:  Remo Rickli
 * Version: 1.1
 */

# VDR Live URL
$src  = 'http://osiris:8008';

# URL to present to Android device (Works for DVB-C, but DVB-S2 seems to end up in download):
$alnk  = 'http://osiris:3000';

# URL to present to IOS device:
$ilnk  = 'vlc-x-callback://x-callback-url/stream?url=http://osiris:3000';

#This shouls work with IOS and Android
$lnk = strpos($_SERVER['HTTP_USER_AGENT'],'Android')?$alnk:$ilnk;
error_reporting(E_ALL & ~(E_WARNING|E_NOTICE));

?>
<html>
<head>
	<title>iVDR</title>
	<meta http-equiv="content-type" content="text/html;charset=ISO-8859-1" />
	<meta name="generator" content="iVDR">
	<meta http-equiv="cache-control" content="no-cache">
	<meta http-equiv="refresh" content="60">
	<link rel="shortcut icon" href="ivdrs.png">
	<link rel="icon" type="image/ico" href="ivdrs.png">
	<link rel="apple-touch-icon" href="ivdr.png">

<style>

body {
	font: 13px "Trebuchet MS", Helvetica, sans-serif;
	background-color: #000;
}

h2   {
	margin: 0px;
	color: #fff;
	font-size: 22px;
	font-weight: bold;
	text-align: center;
	padding: 2px;
	text-shadow: 2px 3px 3px #222;
	border-radius: 4px;
	background: -webkit-linear-gradient( #777 40%, #ccc);
	background: -moz-linear-gradient( #777 40%, #ccc);
}

h3 {
	margin: 0px;
	font-weight: bold;
	color: #026;
}

:link {
	color: #0066ee;
	text-decoration: none;
	transition: color 0.4s ease;
}
:visited {color: #0066cc;text-decoration: none;}
:link:focus, :visited:focus {color: #cccc00}
:link:hover, :visited:hover {
	transition: color 0.8s ease;
	color: #cc8800
}
:link:active, :visited:active {color: #f00000}

.pad{
	color: #000;
	float:left;
	margin: 2px;
	padding: 2px;
	border-radius: 1em;
	width:300px;
	height:200px;
	background-color: #aaa;
	background: -webkit-linear-gradient(#ccc 25%, #666 75%);
	background: linear-gradient( #ccc 25%, #666 75%);
}

.bar{
	padding: 2px;
	background-color: #68a;
	border: 1px solid;
}

.short{
	font-weight: bold;
	color: #246;
}

</style>

</head>
<body>

<?php

$live = file($src);
$i    = -1;

foreach($live as $l){
	if( strpos($l,'<div class="event">') ){
		$i++;
	}

	if( strpos($l,'</a></div></div></div>') ){
		$chn[$i] = preg_replace('/>\d+ - (.*?)<\/a>.*/',"$1",$l);
	}

	if( strpos($l,'<div class="progress">') ){
		$prg[$i] = preg_replace('/.*width: (\d+)px.*/',"$1",$l);
	}

	if( strpos($l,'<div class="title withmargin">') ){
		$tit[$i] = substr($l,36,-7);
	}

	if( strpos($l,'<div class="short withmargin">') ){
		$sht[$i] = substr($l,36,-7);
	}

	if( strpos($l,'<div class="more withmargin">') ){
		$des[$i] = substr($l,46,-46);
	}

	if( strpos($l,'href="vlc.html?channel=') ){
		$vlc[$i] = preg_replace('/.*vlc.html\?channel=([\w\.-]+).*/',"$1",$l);
	}
}

foreach($tit as $i => $t){
?>
<div class="pad">
	<a href="<?= $lnk ?>/<?= trim($vlc[$i]) ?>.ts">
		<h2><?= $chn[$i] ?></h2>
	</a>
	<div class="bar" style="width:<?= trim($prg[$i])*2 ?>px"></div>
	<h3><?= $t ?></h3>
	<div  class="short"><?= $sht[$i] ?></div>
	<?= $des[$i] ?>

</div>

<?php
}
?>
</body>
</html>

